library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity JK is
	port 
		(SET, RESET: IN STD_LOGIC;
    	ENABLE: IN STD_LOGIC;
		CLK: IN STD_LOGIC;
		J1, K1: IN STD_LOGIC;
		J2, K2: IN STD_LOGIC;
		Q1, Q2: OUT STD_LOGIC);		

	attribute pin_numbers of JK:entity is
		"CLK:1 J1:2 K1:3 J2:4 K2:5 SET:6 RESET:7 ENABLE:11 "&
		"Q1:18 Q2:19 ";

end JK;

architecture behavioral of JK is
	signal state1, state2: STD_LOGIC;
begin

	Q1 <= state1 when ENABLE = '0' else
		  'Z';
	Q2 <= state2 when ENABLE = '0' else
		  'Z';

	process (CLK)
	begin
		if (rising_edge(CLK)) then
			state1 <= 
					((NOT RESET) AND (NOT SET) AND ( (state1 AND NOT K1 ) OR (NOT state1  AND J1) ) ) OR
					((NOT RESET) AND SET);

			if (RESET = '1') then
				state2 <= '0';
		    elsif (SET = '1') then
				state2 <= '1';
			else
				state2 <= (state2 AND NOT(K2)) OR (NOT(state2) AND J2);
			end if;		

		end if;
	end process;

end behavioral;