library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity cell is
	port 
		(
		B,C,CLK_in,RST_in: IN STD_LOGIC;
		Q_out : OUT STD_LOGIC);

end cell;

architecture behavioral of cell is
	signal Q: STD_LOGIC;
begin

	Q_out <= Q;

	process (CLK_in, RST_in)
	begin
		if (RST_in = '1') then
			Q <= '0';
		elsif (rising_edge(CLK_in)) then
			Q <= (not B and not C and     Q) or
				 (not B and     C and not Q) or
				 (    B and not C);
		end if;
	end process;

end behavioral;